/*Copyright: Tim vor der Brck 1999

This software is released under the GNU General Public License.
It may be redistributed as long this copyright remark is not
removed or modified.
*/

#ifndef counterh
#define counterh

//************************************* Counter ************************************
/** 
 * Using this class:
 * Derive one class from CPlayfield and  
 * implement all abstract functions.             
 * At the beginning of your class you should have
 * #include "pfad\counter.h" ,
 */
#include "icon.h"

class CPlayfield;
class CCounter;



class CPlayfield
{
public:
	/* Zeichne ein leeres Feld, x,y sind die Brettkoordinaten
	 nicht die Screen-Koordinaten, ob sie ab 0 oder 1
	 beginnen, ist dem Anwender berlassen*/
	virtual void removeicon(int x,int y,CIcon* picon)=0;


	//Zeichne ein Icon
	virtual void drawicon(int x,int y,CIcon* picon)=0;

	//ermittle den Inhalt eines Feldes
	virtual CCounter* getcontents(int x,int y)=0;

	//setze den Inhalt eines Feldes
	virtual void setcontents(int x,int y,CCounter* ss)=0;
};



class CCounter
{
public:
	CCounter(int x,int y,CIcon* picon,int value,CPlayfield* playfield);
	/*x,y: Position auf dem Spielfeld
	  HICON: iconhandle des Spielsteins
	  wert: logischer Wert des Spielsteines
	  dieser ist nicht wichtig fr diese Klasse, ist aber evtl.
	  komfortabel die logische Representation hier zu speichern,
	  wenn dies nicht gebraucht wird, kann er immer auf 0
	  gesetzt werden
	  CSpielfeld: eine von CSpielfeld abgeleitete Klasse,
	  z.B. class CschachView: public CView,CSpielfeld {....}
	  */

	~CCounter();
	

	void smove(int newx,int newy,bool remove=true);
	/* neux, neuy : neue Position des Spielsteines
		loesche gibt an, ob Icon an der Quell-Position gelscht werden
		soll. Bei Drag and Drop-Operationen sollte aus
		Zeitersparnisgruenden hier false stehen, da das Icon
		schon whrend der Drag-Operation sowieso gelscht werden
		muss*/

	CIcon* geticon(); //gibt icon des Spielsteines zurueck

        int getvalue(); //returns value of Counter

	void draw(); //Zeichnet den Spielstein

	CCounter* clone(int x,int y); 
	/* Erzeugt eine Kopie auf angeg. Position, 
	Rckgabewert ist der neuerzeugte Spielstein, falls x,y
	der Position des zu clonenden Spielsteines entspricht wird
	NULL zurckgegeben und nichts passiert*/

	void transform(CIcon* pneuicon,int newvalue);
	/* verwandelt einen Spielstein in einen anderen, 
	Beispiel dafr ist die Bauernbefrderung beim Schach*/

private:
	int m_value;
	CPlayfield* m_playfield; //Zeiger auf das Spielfeld

	CIcon* m_picon; //Iconhandle
	int m_x;	//eigene Position	
	int m_y;
	
};


#endif
