/*Copyright: Tim vor der Brck 1999

This software is released under the GNU General Public License.
It may be redistributed as long this copyright remark is not
removed or modified.
*/

#include <iostream>
//#include <strstream>
//#include <sstream>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xaw/AsciiText.h>
#include "playersetupdialog.h"

static void 
  psdonreturn(Widget w,XEvent *event,String* params,Cardinal* num);

static XtActionsRec actions[]={"psdonreturn",psdonreturn};
static char transTable[]="#override\n <Key>Return: psdonreturn() \n";
static Widget toplevel,playersetupdialog,labelplayer1,togplayer1hum,labelplayer1hum,togplayer1com,
       labelplayer1com,labelplayer1level,textplayer1level,labelplayer2,togplayer2hum,labelplayer2hum,
       togplayer2com,labelplayer2com,labelplayer2level,textplayer2level,
       okleveldlg,cancelleveldlg,formmsg,formplayer1,formplayer2;
static bool bfirsttime=true;
static CCaller* pcaller;
static XtAppContext appcontext;

//************************ onreturn *******************************
static void 
  psdonreturn(Widget w,XEvent *event,String* params,Cardinal* num)
{
  
}


//************************* initplayersetupdialog *******************************
/** 
 * should be called before you call popupplayersetupdialog the first time
 * it is safe to call this function more than once
 *
 * @param top  application toplevel widget
 * @param c  pointer to class that implements 
 *           the methods setvalues,oncancel,psdhandleerror
 */
void initplayersetupdialog(Widget top,XtAppContext appcon,CCaller* c)
{
  pcaller=c;
  toplevel=top;
  appcontext=appcon;
  
}

//**************************** popdownplayersetupdialog *************************
void popdownplayersetupdialog()
{
  XtPopdown(playersetupdialog);
} 

//*************************** ontogplayer1hum ************************************
void ontogplayer1hum(Widget w,XtPointer client,XtPointer call)
{
  String str;
  Boolean st;
  XtVaGetValues(togplayer1hum,XtNstate,&st,NULL);
  if (st==TRUE)
  {
     XtVaSetValues(textplayer1level,XtNsensitive,False,NULL);
  }
  else
  {
     XtVaSetValues(textplayer1level,XtNsensitive,True,NULL);
  }
}

//*************************** ontogplayer2hum ************************************
void ontogplayer2hum(Widget w,XtPointer client,XtPointer call)
{
  String str;
  Boolean st;
  XtVaGetValues(togplayer2hum,XtNstate,&st,NULL);
  if (st==TRUE)
  {
     XtVaSetValues(textplayer2level,XtNsensitive,False,NULL);
  }
  else
  {
     XtVaSetValues(textplayer2level,XtNsensitive,True,NULL);
  }
}



//*************************** pushcancel *****************************************
void pushcancel(Widget w,XtPointer client,XtPointer call)
{
  pcaller->oncancel();
}
 
//*************************** pushok *********************************************
void pushok(Widget w,XtPointer client,XtPointer call)
{
  String slev0,slev1;
  int lev0,lev1; 
  Boolean s0,s1; // state

  // get level of players
  XtVaGetValues(togplayer1hum,XtNstate,&s0,NULL);
  XtVaGetValues(togplayer2hum,XtNstate,&s1,NULL);

  // in Strings
  XtVaGetValues(textplayer1level,XtNstring,&slev0,NULL);
  XtVaGetValues(textplayer2level,XtNstring,&slev1,NULL);
  
  //in numbers
  lev0=atoi(slev0);
  lev1=atoi(slev1);

  // if player 1 computer then take value from the text field, otherwise 0
  if (s0==TRUE) lev0=0;
  
  // if player 2 computer then take value from the text field, otherwise 0
  if (s1==TRUE) lev1=0;

  //error handling

  // neither human or computer selected
  Boolean t0,t1;
  XtVaGetValues(togplayer1com,XtNstate,&t0,NULL);
  XtVaGetValues(togplayer2com,XtNstate,&t1,NULL);  
  if ((t0==False && s0==False) || (s1==False && t1==False))
  {
    pcaller->psdhandleerror(PSDNOSELECT);
    return;
  }

  //level is zero but player is a computer
  if (lev0<0 || lev1<0 || lev0>99 || lev1>99 || 
      (lev0==0 && s0==FALSE) || 
      (lev1==0 && s1==FALSE) ) 
  {
     pcaller->psdhandleerror(PSDOUTOFRANGE);
     return;
  }


  pcaller->setvalues(lev0,lev1);
  
}
 
//**************************** interninitMessageBox *****************************
void interninitplayersetupdialog()
{
  XtAppAddActions(appcontext,actions,XtNumber(actions));
  playersetupdialog=XtVaCreatePopupShell("playersetupdialog",transientShellWidgetClass,toplevel,XtNinput,True,NULL);
  formmsg=XtVaCreateManagedWidget("formmsg",formWidgetClass,playersetupdialog,NULL);
  formplayer1=XtVaCreateManagedWidget("formplayer1",formWidgetClass,formmsg,NULL);
  formplayer2=XtVaCreateManagedWidget("formplayer2",formWidgetClass,formmsg,XtNfromHoriz,formplayer1,NULL);

  // player1
  labelplayer1=XtVaCreateManagedWidget("labelplayer1",labelWidgetClass,formplayer1,NULL);
  togplayer1hum=XtVaCreateManagedWidget("togplayer1hum",toggleWidgetClass,formplayer1,XtNfromVert,labelplayer1,NULL);
  //labelplayer1hum=XtVaCreateManagedWidget("labelplayer1hum",labelWidgetClass,formplayer1,XtNfromHoriz,togplayer1hum,NULL);
  togplayer1com=XtVaCreateManagedWidget("togplayer1com",toggleWidgetClass,formplayer1,XtNfromVert,togplayer1hum,NULL);
  //labelplayer1com=XtVaCreateManagedWidget("labelplayer1com",labelWidgetClass,formplayer1,XtNfromHoriz,togplayer1com,NULL);
  labelplayer1level=XtVaCreateManagedWidget("labelplayer1level",labelWidgetClass,formplayer1,XtNfromVert,togplayer1com,NULL);
  textplayer1level=XtVaCreateManagedWidget("textplayer1level",asciiTextWidgetClass,formplayer1,XtNfromVert,labelplayer1level,
               XtNeditType,XawtextEdit,XtNtype,XawAsciiString,
    XtNtranslations,XtParseTranslationTable(transTable),NULL);
  XawToggleChangeRadioGroup(togplayer1hum,togplayer1hum);
  XawToggleChangeRadioGroup(togplayer1com,togplayer1hum);
  

  labelplayer2=XtVaCreateManagedWidget("labelplayer2",labelWidgetClass,formplayer2,NULL);
  togplayer2hum=XtVaCreateManagedWidget("togplayer2hum",toggleWidgetClass,formplayer2,XtNfromVert,labelplayer2,NULL); 
  //labelplayer2hum=XtVaCreateManagedWidget("labelplayer2hum",labelWidgetClass,formplayer2,XtNfromHoriz,togplayer2hum,NULL);
  togplayer2com=XtVaCreateManagedWidget("togplayer2com",toggleWidgetClass,formplayer2,XtNfromVert,togplayer2hum,NULL);
  //labelplayer2com=XtVaCreateManagedWidget("labelplayer2com",labelWidgetClass,formmsg,XtNfromHoriz,togplayer2com,NULL);
  labelplayer2level=XtVaCreateManagedWidget("labelplayer2level",labelWidgetClass,formplayer2,XtNfromVert,togplayer2com,NULL);
  textplayer2level=XtVaCreateManagedWidget("textplayer2level",asciiTextWidgetClass,formplayer2,XtNfromVert,labelplayer2level,
		XtNeditType,XawtextEdit,XtNtype,XawAsciiString,
                XtNtranslations,XtParseTranslationTable(transTable),NULL);
  XawToggleChangeRadioGroup(togplayer2hum,togplayer2hum);
  XawToggleChangeRadioGroup(togplayer2com,togplayer2hum);
  

  //ok and cancel
  okleveldlg=XtVaCreateManagedWidget("okleveldlg",commandWidgetClass,formmsg,XtNfromVert,formplayer1,NULL);
  cancelleveldlg=XtVaCreateManagedWidget("cancelleveldlg",commandWidgetClass,formmsg,XtNfromVert,okleveldlg,NULL);

  XtAddCallback(cancelleveldlg,XtNcallback,pushcancel,NULL);
  XtAddCallback(okleveldlg,XtNcallback,pushok,NULL);
  XtAddCallback(togplayer1hum,XtNcallback,ontogplayer1hum,NULL);
  XtAddCallback(togplayer2hum,XtNcallback,ontogplayer2hum,NULL);

}


//******************** popupplayersetupdialog *************************
/* message: output string
   realize: realises widget, should be set, if 
   MessageBox is poped up the first time after
   the command: Realize(toplevel) */
void popupplayersetupdialog(int lev0,int lev1,bool realize)
{
  Position x,y;
  Dimension width,height;
  char slev0[10],slev1[10];
  //ostrstream slev0stream(slev0,9),slev1stream(slev1,9);

  //first time, then initialize messagebox
  if (bfirsttime)  interninitplayersetupdialog();

  // position dialog 
  XtVaGetValues(toplevel,XtNwidth,&width,XtNheight,&height,NULL);
  XtTranslateCoords(toplevel,(Position)width/2,(Position)height/2,&x,&y);
  XtVaSetValues(playersetupdialog,XtNx,x,XtNy,y,NULL);
  
  // set leveltextfields and togglebuttons

  // if level of player 1 not equal to zero, player 1 is computer controlled
  if (lev0!=0) 
  {
    sprintf(slev0,"%i",lev0);
    XtVaSetValues(textplayer1level,XtNstring,slev0,NULL);
    XtVaSetValues(togplayer1com,XtNstate,True,NULL);
  }
  else
  { 
    XtVaSetValues(togplayer1hum,XtNstate,True,NULL);
    XtVaSetValues(textplayer1level,XtNsensitive,False,NULL);
  }

  // the same for player 2
  if (lev1!=0) 
  {
    //_myitoa(slev1,lev1,10);
    sprintf(slev1,"%i",lev1);
    //slev1stream << lev1 << '\0';
    //gcvt(double(lev1),9,slev1);
    XtVaSetValues(textplayer2level,XtNstring,slev1,NULL);
    XtVaSetValues(togplayer2com,XtNstate,True,NULL);
  }
  else 
  {
    XtVaSetValues(togplayer2hum,XtNstate,True,NULL);
    XtVaSetValues(textplayer2level,XtNsensitive,False,NULL);
  }
 
  //realize dialog
  if (bfirsttime)
  {
    bfirsttime=false;
    if (realize) XtRealizeWidget(playersetupdialog);
  }
  XtPopup(playersetupdialog,XtGrabNonexclusive);
}


  
