/** copyright Tim vor der Brck 
 * this source code is distributed under the Gnu General Public License
 */
#include <iostream>
#include <string>
#include <stdlib.h>
#include "statuswindow.h"

using namespace std;

Statuswindow::Statuswindow(Display* display,int width,int height)
{
  m_display=display;
  m_width=width;
  m_height=height;
  m_screennr=DefaultScreen(m_display);
  m_defroot=DefaultRootWindow(m_display);
  m_root=RootWindow(m_display,m_screennr);
  m_depth=DefaultDepth(m_display,m_screennr);
  m_gc=XCreateGC(m_display,m_root,0,NULL);
  m_pixmap=XCreatePixmap(m_display,m_defroot,m_width,m_height,m_depth);

 // load font
  m_pfs=XLoadQueryFont(m_display,"*courier-*-r-normal--10*");
  if (m_pfs==0) 
  {
    cout << "unable to load font" << endl;
    exit(10);
  }
  XSetFont(m_display,m_gc,m_pfs->fid);  
}

Statuswindow::~Statuswindow()
{
  XFreePixmap(m_display,m_pixmap);
  XFreeGC(m_display,m_gc);
}


void Statuswindow::clear()
{
 int fg=BlackPixel(m_display,m_screennr);
  int bg=WhitePixel(m_display,m_screennr);

  //set pen color to white
  XSetForeground(m_display,m_gc,bg);

  XFillRectangle(m_display,m_pixmap,m_gc,0,0,m_width,m_height);

  //set pen color to black
  XSetForeground(m_display,m_gc,fg);
}

void Statuswindow::draw(Window win)
{
  XCopyArea(m_display,m_pixmap,win,m_gc,0,0,m_width,m_height,0,0);
}

void Statuswindow::drawStrings(string ppstr[],int num)
{
  for (int i=0;i<num;i++)
  {
    cout << ppstr[i] << endl;
    XDrawString(m_display,m_pixmap,m_gc,10,20+i*(m_pfs->ascent+m_pfs->descent+2),ppstr[i].c_str(),ppstr[i].size());
  }
}
