/*Copyright: Tim vor der Brck 1999

This software is released under the GNU Library General Public License.
It may be redistributed as long this copyright remark is not
removed or modified.
*/

#include <stdio.h>
#include <X11/StringDefs.h>
#include <X11/IntrinsicP.h>
#include <X11/Xaw/Command.h>
#include "IconSelP.h"
#define offset(field) XtOffsetOf(IconSelectorRec, field)

static XtResource resources[]=
{
  {XtNcallback,XtCCallback,XtRCallback,sizeof(XtPointer),
   offset(iconSelector.callback),XtRCallback,NULL},
  {XvNbitmaps,XvCbitmaps,XtRPointer,sizeof(XtPointer),
   offset(iconSelector.bitmaps),XtRPointer,NULL}
};

static void Initialize();
static void Redisplay();
static void Destroy();

static Boolean SetValues();

IconSelectorClassRec iconSelectorClassRec=
{
  {
      /* core_class fields      */
      /* superclass         */    (WidgetClass) &boxClassRec,
      /* class_name         */    "IconSelector",
      /* widget_size        */    sizeof(IconSelectorRec),
      /* class_initialize   */    NULL, /*ClassInitialize,*/
      /* class_part_init    */	NULL,
      /* class_inited       */	FALSE,
      /* initialize         */    Initialize,
      /* initialize_hook    */	NULL,
      /* realize            */    XtInheritRealize, /*Realize,*/
      /* actions            */    NULL,
      /* num_actions	  */	0,
      /* resources          */    resources,
      /* num_resources      */    XtNumber(resources),
      /* xrm_class          */    NULLQUARK,
      /* compress_motion	  */	TRUE,
      /* compress_exposure  */	TRUE,
      /* compress_enterleave*/	TRUE,
      /* visible_interest   */    FALSE,
      /* destroy            */    NULL,
      /* resize             */    XtInheritResize, /*Resize,*/
      /* expose             */    NULL,
      /* set_values         */    SetValues,
      /* set_values_hook    */	NULL,
      /* set_values_almost  */    XtInheritSetValuesAlmost,
      /* get_values_hook    */	NULL,
      /* accept_focus       */    NULL,
      /* version            */	XtVersion,
      /* callback_private   */    NULL,
      /* tm_table           */    NULL,
      /* query_geometry     */	XtInheritQueryGeometry, /*PreferredSize,*/
      /* display_accelerator*/	XtInheritDisplayAccelerator,
      /* extension          */	NULL
  },
  {
      /* composite_class fields */
      /* geometry_manager   */    XtInheritGeometryManager,
      /* change_managed     */    XtInheritChangeManaged,
      /* insert_child	  */	XtInheritInsertChild,
      /* delete_child	  */	XtInheritDeleteChild,
      /* extension          */	NULL
  },
  {
      /* Box class fields */
      /* empty		  */	0,
  },
  { /*IconSelector class fields*/
    0
  }
};


WidgetClass iconSelectorWidgetClass=(WidgetClass)&iconSelectorClassRec;

static void onpress(Widget w,XtPointer client,XtPointer call)
{
  Widget parent=XtParent(w);
  IconSelectorWidget iw=(IconSelectorWidget)parent;
  iw->iconSelector.selinfo.no=(int)client;
  XtCallCallbacks(parent,XtNcallback,&(iw->iconSelector.selinfo));
}

int getnumberofbitmaps(Pixmap* bitmaps)
{
  int i=0;
  /*get number of bitmaps*/
  while (bitmaps[i]!=0)
    i++;
  return i;
}

void deleteoldbuttons(Widget w) 
{
  int i;
  IconSelectorWidget icselold=(IconSelectorWidget)w;

  if (icselold->iconSelector.buttons!=NULL)
  {
    for (i=0;i<icselold->iconSelector.numberofbitmaps;i++)
    {
      XtDestroyWidget(icselold->iconSelector.buttons[i]);
    }
    free(icselold->iconSelector.buttons);
  }
  if (icselold->iconSelector.numberofchoice!=NULL)
     free(icselold->iconSelector.numberofchoice);
}

void createnewbuttons(Widget w) 
{
  char nameofbutton[]="button1";
  IconSelectorWidget icselnew=(IconSelectorWidget)w;
  int i,num=icselnew->iconSelector.numberofbitmaps;

  /*alloc memory*/
  icselnew->iconSelector.buttons=(Widget*)
    malloc(num*sizeof(Widget));
  icselnew->iconSelector.numberofchoice=(int*)
    malloc(num*sizeof(int));
  

  
  for (i=0;i<num;i++,nameofbutton[6]++)
  {
    icselnew->iconSelector.buttons[i]=
        XtVaCreateManagedWidget(nameofbutton,commandWidgetClass,
               w,XtNbitmap,icselnew->iconSelector.bitmaps[i],NULL);
    icselnew->iconSelector.numberofchoice[i]=i;
    XtAddCallback(icselnew->iconSelector.buttons[i],
                  XtNcallback,onpress,(void*)i);
          /*&(icselnew->iconSelector.numberofchoice[i]));*/
  }
}

void reinit(Widget old,Widget new)
{

  /*delete old bitmap buttons*/
  deleteoldbuttons(old);
  
  /*create new bitmaps buttons*/
  createnewbuttons(new); 
  
}

static void Initialize(Widget treq,Widget tnew,ArgList args,Cardinal* num)
{
  int no=0;
  IconSelectorWidget icsel=(IconSelectorWidget) tnew;
  
  /*get number of bitmaps the user provides*/
  icsel->iconSelector.numberofbitmaps=
      getnumberofbitmaps(icsel->iconSelector.bitmaps);

  /*init fields*/
  icsel->iconSelector.buttons=NULL;

  /*init*/
  createnewbuttons(tnew);
  
}

static Boolean SetValues(Widget current,Widget request,Widget super,
		      ArgList args,Cardinal* num)
{
  IconSelectorWidget old=(IconSelectorWidget)current;
  IconSelectorWidget new=(IconSelectorWidget)super;

  if (old->iconSelector.bitmaps!=new->iconSelector.bitmaps) 
  { 
     new->iconSelector.numberofbitmaps=
            getnumberofbitmaps(new->iconSelector.bitmaps);
     reinit(current,super);
     return True;
  }
  return False;
}


static void Destroy(Widget w)
{
  deleteoldbuttons(w);
}
  
